import josx.platform.rcx.*;

public class LightSensorListener implements SensorListener {
	
	int blackValue;

	private LineSeek lineSeek;

	public LightSensorListener(Sensor sensor, Thread mainThread) {
		sensor.setTypeAndMode(3,0x80);
		sensor.activate();
		
		try {
			Thread.sleep(500);
		} catch (InterruptedException e) {};
		
		blackValue = sensor.readValue();
		
		lineSeek = new LineSeek(mainThread);
		lineSeek.start();
		
		sensor.addSensorListener(this);
	}

	public void stateChanged(Sensor source, int oldValue, int newValue) {
		//line has been lost
		if (!lineSeek.isSeeking() && (newValue > blackValue + 10)) {
			lineSeek.startSeeking();
		}
		//line has been found
		if (lineSeek.isSeeking() && (newValue < blackValue + 10)) {
			Sound.beep();
			lineSeek.stopSeeking();
		}
	}

}
