import josx.platform.rcx.*;

public class LineSeek extends Thread implements Constants {
		
	private boolean seeking = false;
	
	private boolean waiting = false;

	public LineSeek(Thread mainThread) {
		setDaemon(true);
	}
	
	public synchronized void startSeeking() {
		
		if (seeking || !waiting)
			return;
		
		seeking = true;
			
		synchronized (this) {
			notify();
		} 
	}
	
	public synchronized void stopSeeking() {
		
		if (!seeking || waiting)
			return;
		
		seeking = false;
		
		TextLCD.print("fwd");
		
		interrupt();
	}

	public synchronized boolean isSeeking() {
		return seeking;
	}

	public void run() {
		
		while (true) {
			try {
				synchronized (this) {
					waiting = true;
					wait();
					waiting = false;
					
				}
			} catch (InterruptedException e1) {
				//sollte nie ausgef?hrt werden
				Sound.beepSequence();
				try {
					Thread.sleep(3000);
				} catch (InterruptedException e) {
				}
				AbstractApplication.mainThread.interrupt();
			}
			try {
				algorithm();
				AbstractApplication.mainThread.interrupt();
			} catch (InterruptedException e) {
				SeekLineApplication.move(FORWARD);
			}
		}
		
	}
	
	private byte lastDirection = LEFT;
	
	private void algorithm() throws InterruptedException {
		
		//stop motors
		SeekLineApplication.move(STOP);
		Thread.sleep(25);
		
		//turn to left and then to right and then to the left and then...
		short sec = 100;
		byte direction = lastDirection;
		for (byte i = 0; i < 3; i++) {

			TextLCD.print("Seek");
			LCD.showProgramNumber(i);

			//turn to last direction
			SeekLineApplication.move(direction);

			//calculate duration in dependence of real motor power
			short realsec = (lastDirection == LEFT) ? (short) (1.12 * sec) : sec;
			
			//add time for motors to change direction
			realsec += 30;
			
			lastDirection = direction;
			Thread.sleep(realsec);

			//other direction for next try
			direction *= -1;
			sec *= 2;
			SeekLineApplication.move(STOP);
			Thread.sleep(25);
		}
		
	}

}
